# Ant User Manual

## Typedef

### Description

Adds a data type definition to the current project, such that this new type can be used in the current project. Two attributes are needed, the name that identifies this data type uniquely, and the full name of the class (including the packages) that implements this type.

Typedef should be used to add your own types to the system. Data types are things like paths or filesets that can be defined at the project level and referenced via their ID attribute.

Custom data types usually need custom tasks to put them to good use.

### Parameters

Attribute | Description | Required
name | the name of the data type | Yes
classname | the full class name implementing the data type | Yes
classpath | the classpath to use when looking up `classname`. | No

### Parameters specified as nested elements

#### classpath

`Typedef`'s classpath attribute is a PATH like structure and can also be set via a nested classpath element.

### Examples

      <typedef name="urlset" classname="com.mydomain.URLSet"/>

makes a data type called `urlset` available to Ant. The class `com.mydomain.URLSet` implements this type.

Copyright © 2000,2001 Apache Software Foundation. All rights Reserved.